package com.ruoyi.system.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.AllArgsConstructor;
import lombok.experimental.SuperBuilder;
import io.swagger.annotations.*;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.system.domain.req.TClazzQueryReq;
import com.ruoyi.system.domain.req.TClazzSaveReq;
import com.ruoyi.system.domain.req.TClazzEditReq;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 班级管理对象 t_clazz
 *
 * @author 付凡芮
 * @date 2024-04-22
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@TableName("t_clazz")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "TClazz", description = "班级管理")
public class TClazz extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /** 班级id */
    @TableId(value = "clazz_id",type = IdType.AUTO)
    @ApiModelProperty(name = "班级id", value = "班级id")
    private Long clazzId;

    /** 班级名称 */
    @Excel(name = "班级名称")
    @ApiModelProperty(name = "班级名称", value = "班级名称")
    private String clazzName;

    /** 班级状态 */
    @Excel(name = "班级状态")
    @ApiModelProperty(name = "班级状态", value = "班级状态")
    private String clazzState;

    /** 班级创建人 */
    @Excel(name = "班级创建人")
    @ApiModelProperty(name = "班级创建人", value = "班级创建人")
    private String clazzFounder;



    /**
    * 查询构造器
    */
    public static TClazz queryBuild( TClazzQueryReq tClazzQueryReq){
        return TClazz.builder()
                .clazzName(tClazzQueryReq.getClazzName())
                .clazzState(tClazzQueryReq.getClazzState())
                .clazzFounder(tClazzQueryReq.getClazzFounder())
                .build();
    }

    /**
    * 添加构造器
    */
    public static TClazz saveBuild(TClazzSaveReq tClazzSaveReq){
        return TClazz.builder()
                .clazzName(tClazzSaveReq.getClazzName())
                .clazzState(tClazzSaveReq.getClazzState())
                .clazzFounder(tClazzSaveReq.getClazzFounder())
                .build();
    }

    /**
    * 修改构造器
    */
    public static TClazz editBuild(Long clazzId, TClazzEditReq tClazzEditReq){
        return TClazz.builder()
            .clazzId(clazzId)
                .clazzName(tClazzEditReq.getClazzName())
                .clazzState(tClazzEditReq.getClazzState())
                .clazzFounder(tClazzEditReq.getClazzFounder())
                .build();
    }

}
