package com.ruoyi.system.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.AllArgsConstructor;
import lombok.experimental.SuperBuilder;
import io.swagger.annotations.*;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.system.domain.req.TGroupQueryReq;
import com.ruoyi.system.domain.req.TGroupSaveReq;
import com.ruoyi.system.domain.req.TGroupEditReq;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 班级小组管理对象 t_group
 *
 * @author 付凡芮
 * @date 2024-04-23
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@TableName("t_group")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "TGroup", description = "班级小组管理")
public class TGroup extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /** 小组id */
    @TableId(value = "group_id",type = IdType.AUTO)
    @ApiModelProperty(name = "小组id", value = "小组id")
    private Long groupId;

    /** 小组名称 */
    @Excel(name = "小组名称")
    @ApiModelProperty(name = "小组名称", value = "小组名称")
    private String groupName;

    /** 小组状态 */
    @Excel(name = "小组状态")
    @ApiModelProperty(name = "小组状态", value = "小组状态")
    private String groupState;

    /** 小组负责人 */
    @Excel(name = "小组负责人")
    @ApiModelProperty(name = "小组负责人", value = "小组负责人")
    private String groupLeader;

    /** 所属班级 */
    @Excel(name = "所属班级")
    @ApiModelProperty(name = "所属班级", value = "所属班级")
    private Long clazzId;

    /** 班级 */
    private TClazz clazz;

    /**
    * 查询构造器
    */
    public static TGroup queryBuild( TGroupQueryReq tGroupQueryReq){
        return TGroup.builder()
                .groupName(tGroupQueryReq.getGroupName())
                .groupState(tGroupQueryReq.getGroupState())
                .groupLeader(tGroupQueryReq.getGroupLeader())
                .clazzId(tGroupQueryReq.getClazzId())
                .build();
    }

    /**
    * 添加构造器
    */
    public static TGroup saveBuild(TGroupSaveReq tGroupSaveReq){
        return TGroup.builder()
                .groupName(tGroupSaveReq.getGroupName())
                .groupState(tGroupSaveReq.getGroupState())
                .groupLeader(tGroupSaveReq.getGroupLeader())
                .clazzId(tGroupSaveReq.getClazzId())
                .build();
    }

    /**
    * 修改构造器
    */
    public static TGroup editBuild(Long groupId, TGroupEditReq tGroupEditReq){
        return TGroup.builder()
            .groupId(groupId)
                .groupName(tGroupEditReq.getGroupName())
                .groupState(tGroupEditReq.getGroupState())
                .groupLeader(tGroupEditReq.getGroupLeader())
                .clazzId(tGroupEditReq.getClazzId())
                .build();
    }

}
