package com.ruoyi.system.service.impl;

import java.util.List;

import com.ruoyi.common.core.domain.Result;
import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.utils.ObjUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.system.domain.req.TClazzSaveReq;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.security.core.token.TokenService;
import org.springframework.stereotype.Service;
import com.ruoyi.system.mapper.TClazzMapper;
import com.ruoyi.system.domain.TClazz;
import com.ruoyi.system.service.TClazzService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;

/**
 * 班级管理Service业务层处理
 *
 * @author 付凡芮
 * @date 2024-04-22
 */
@Slf4j
@Service
public class TClazzServiceImpl extends ServiceImpl<TClazzMapper, TClazz>  implements TClazzService {

//    @Lazy
//    @Autowired
//    private TClazzService tClazzService;
//

    /**
     * 查询班级管理列表
     *
     * @param tClazz 班级管理
     * @return 班级管理
     */
    @Override
    public List<TClazz> list(TClazz tClazz) {
        LambdaQueryWrapper<TClazz> queryWrapper = new LambdaQueryWrapper<>();


        if (ObjUtils.notNull(tClazz.getClazzName())){
            queryWrapper.like(TClazz::getClazzName, tClazz.getClazzName());
        }

        if (ObjUtils.notNull(tClazz.getClazzState())){
            queryWrapper.eq(TClazz::getClazzState, tClazz.getClazzState());
        }

        if (ObjUtils.notNull(tClazz.getClazzFounder())){
            queryWrapper.eq(TClazz::getClazzFounder, tClazz.getClazzFounder());
        }
        return list(queryWrapper);
    }

}
