package com.ruoyi.system.service.impl;

import java.util.List;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.utils.ObjUtils;
import com.ruoyi.common.utils.StringUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import com.ruoyi.system.mapper.TGroupMapper;
import com.ruoyi.system.domain.TGroup;
import com.ruoyi.system.service.TGroupService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;

/**
 * 班级小组管理Service业务层处理
 *
 * @author 付凡芮
 * @date 2024-04-23
 */
@Slf4j
@Service
public class TGroupServiceImpl extends ServiceImpl<TGroupMapper, TGroup>  implements TGroupService {

    /**
     * 查询班级小组管理列表
     *
     * @param tGroup 班级小组管理
     * @return 班级小组管理
     */
    @Override
    public List<TGroup> list(TGroup tGroup) {
        LambdaQueryWrapper<TGroup> queryWrapper = new LambdaQueryWrapper<>();


        if (ObjUtils.notNull(tGroup.getGroupName())){
            queryWrapper.like(TGroup::getGroupName, tGroup.getGroupName());
        }

        if (ObjUtils.notNull(tGroup.getGroupState())){
            queryWrapper.eq(TGroup::getGroupState, tGroup.getGroupState());
        }

        if (ObjUtils.notNull(tGroup.getGroupLeader())){
            queryWrapper.eq(TGroup::getGroupLeader, tGroup.getGroupLeader());
        }

        if (ObjUtils.notNull(tGroup.getClazzId())){
            queryWrapper.eq(TGroup::getClazzId, tGroup.getClazzId());
        }

        return list(queryWrapper);
    }
}
